###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import calendar_event
import base_item
import utils

calendar_day_add_redirect = HTMLFile('calendar_day_add_redirect', globals())
manage_add_calendar_day_form = HTMLFile('calendar_day_add', globals())


def manage_add_calendar_day(self, id, title, REQUEST=None):
    "Add an instance of the calendar_day class"

    self._setObject(id, calendar_day(id, title))

    if REQUEST is not None:

        return self.manage_main(self, REQUEST)


class calendar_day(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'CalendarDay'
	icon = 'misc_/Transform/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		)

	meta_types = (
		{'name':'CalendarEvent', 'action':'manage_add_calendar_event_form'},
		)

	manage_add_calendar_event_form = calendar_event.manage_add_calendar_event_form
	manage_add_calendar_event = calendar_event.manage_add_calendar_event
	calendar_event_add_redirect = calendar_event.calendar_event_add_redirect

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add CalendarEvent',
		 ('manage_add_calendar_event', 'manage_add_calendar_event_form')),
		('View CalendarDays',
		 ('',)),
		)

	index_html = HTMLFile('calendar_day_index', globals())

	def __init__(self, id, title=''):
		"Initialize the class instance"

		self.id = id
		self.title = title


	def display(self, manage=1):
		"""Returns an HTML formatted output of the current day and events."""

		events = self.objectValues('CalendarEvent')

		if not events:

			return "<h3>No events for %s</h3>" % self.title

		tmp = """<table border="0" cellpadding="%s" cellspacing="%s"
		valign="top" bgcolor="%s" width="100%%">
		<tr bgcolor="%s"><th colspan="3" align="center">Events</th></tr>
		<tr bgcolor="%s"><th>Time</th><th>Title</th><th>Priority</th></tr>
		""" % \
		(self.table_cellpadding0,
		 self.table_cellspacing0,
		 self.color_body1,
		 self.color_header1,
		 self.color_header0)

		for calendar_event in range(len(events)):

			if calendar_event % 2:

				bgcolor = self.color_sequence_even0

			else:

				bgcolor = self.color_sequence_odd0

			tmp = tmp + """
			<tr bgcolor="%s">
			<td width="25%%" valign="top"><a href="%s">%s - %s</a>&nbsp;</td>
			<td valign="top">%s&nbsp;</td>
			<td valign="top">%s&nbsp;</td>
			</tr>""" % \
				  (bgcolor,
				   events[calendar_event].absolute_url(),
				   utils.format_time(events[calendar_event].start),
				   utils.format_time(events[calendar_event].end),
				   events[calendar_event].title,
				   events[calendar_event].render_priority())

		tmp = tmp + """</table>"""

		return tmp

			

default__class_init__(calendar_day)

