###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.1 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import news
import base_item

categoryAdd2 = HTMLFile('categoryAdd2', globals())
manage_addCategoryForm = HTMLFile('categoryAdd', globals())


def manage_addCategory(self, id, title, description, public, REQUEST=None):
    "Add an instance of the Category class"

    self._setObject(id, Category(id, title, description, public))

    if REQUEST is not None:

        return self.manage_main(self, REQUEST)


class Category(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'Category'
	icon = 'misc_/NewsFolder/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'description', 'type':'text'},
		{'id':'public', 'type':'boolean'},
		)

	meta_types = (
		{'name':'News', 'action':'manage_addNewsForm'},
		)

	manage_addNewsForm = news.manage_addNewsForm
	manage_addNews = news.manage_addNews
	newsAdd2 = news.newsAdd2

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add News',
		 ('manage_addNews', 'manage_addNewsForm')),
		('View Categorys',
		 ('',)),
		)

	index_html = HTMLFile('categoryIndex', globals())
	base_edit = HTMLFile('category_edit', globals())

	def __init__(self, id, title='', description='', public=''):
		"Initialize the class instance"

		self.id = id
		self.title = title
		self.description = description

		self.public = public


	def get_news(self):
		"""Returns a time-sorted list of news-items."""

		news_items = self.objectValues('News')

		news_items.sort(
			lambda x,y: cmp(x.bobobase_modification_time,
							y.bobobase_modification_time)
			)

		return news_items

default__class_init__(Category)

