###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Erik Enge <erik@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.4 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import note
import base_item


notesortAdd2 = HTMLFile('notesortAdd2', globals())
manage_addNoteSortForm = HTMLFile('notesortAdd', globals())


def manage_addNoteSort(self, id, description, REQUEST=None, RESPONSE=None):
    "Add an instance of the NoteSort class"

    self._setObject(id, NoteSort(id, description))

    if RESPONSE is not None:

		RESPONSE.redirect(self.absolute_url())

		


class NoteSort(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'NoteSort'
	icon = 'misc_/Transform/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'description', 'type':'text'},
		)

	meta_types = (
		{'name':'Note', 'action':'manage_addNoteForm'},
		)

	manage_addNoteForm = note.manage_addNoteForm
	manage_addNote = note.manage_addNote
	noteAdd2 = note.noteAdd2

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add Note',
		 ('manage_addNote', 'manage_addNoteForm')),
		('View NoteSorts',
		 ('',)),
		)

	index_html = HTMLFile('notesortIndex', globals())
	manage_edit2 = HTMLFile('notesortEdit2', globals())
	manage_edit3 = HTMLFile('notesortEdit3', globals())


	def __init__(self, id, title,description=''):
		"Initialize the class instance"

		self.id = id
		self.title = title
		self.description = description


default__class_init__(NoteSort)

